# Midictrl-Companion

Read signals from a MIDI device and redirect them to Bitfocus Companion.

## Requirements

- `alsa-utils` must be installed
- Running instance of [Bitfocus Companion](https://bitfocus.io/companion)

## Setup

First, clone this repository:
```sh
$ git clone https://git.abmgrt.dev/rainloreley/midictrl-companion.git
$ cd midictrl-companion
```

Connect the MIDI device and run
```sh
$ aseqdump -l
 Port    Client name                      Port name
 0:0    System                           Timer
 0:1    System                           Announce
14:0    Midi Through                     Midi Through Port-0
24:0    Arduino Micro                    Arduino Micro MIDI 1
...
```
to get the device name of the MIDI device.

Edit the `midictl.sh` file and change the following variables:
- `MIDI_CLIENT`: The client name you just got from the command before
- `BANK`: The id of the bank in Bitfocus Companion you want to control

Now make the file executable and copy it to `/usr/local/bin`:
```sh
$ chmod +x midictrl.sh
$ mv midictrl.sh /usr/local/bin
# If using systemd:
$ mv midictrl.service /etcx/systemd/system
$ systemctl daemon-reload
$ systemctl enable midictrl.service --now
```

Currently you have to restart the service/script if you connect the MIDI device after the computer is started.

## License
This code is licensed under the MIT license